// MainDlg.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "MainDlg.h"
#include "cmath"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainDlg dialog
extern CRITICAL_SECTION CrSect;
extern CThreadData ThreadData;

CMainDlg::CMainDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMainDlg::IDD, pParent)
	, m_bUpdate(FALSE)
{
	//{{AFX_DATA_INIT(CMainDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_bQuit = 0;
//	m_Osc0.SetID(0);
//	m_Osc1.SetID(1);
}


void CMainDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMainDlg)
	DDX_Control(pDX,IDC_OSC0,m_Osc0);
	DDX_Control(pDX,IDC_OSC1,m_Osc1);

	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMainDlg, CDialog)
	//{{AFX_MSG_MAP(CMainDlg)
	ON_WM_PAINT()
	ON_WM_CLOSE()
	ON_MESSAGE(WM_NEWDATA, OnNewData)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainDlg message handlers
void CMainDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
	m_Osc0.OnPaint();
	m_Osc1.OnPaint();
}

void CMainDlg::PrepareViews()
{
	m_Osc0.Create(this,IDC_OSC0, 8);
	m_Osc1.Create(this, IDC_OSC1, 8);
}

BOOL CMainDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	PrepareViews();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon


	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}



HCURSOR CMainDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CMainDlg::OnClose() 
{
	if (!m_bQuit)
		ShowWindow(SW_MINIMIZE);
	else{
		CDialog::OnClose();
	}
}


void CMainDlg::OnCancel()
{
/*	if (!m_bQuit)
		ShowWindow(SW_MINIMIZE);
	else{
		CDialog::OnClose();
	}
*/
}

void CMainDlg::OnOK()
{
/*	if (!m_bQuit)
		ShowWindow(SW_MINIMIZE);
	else{
		CDialog::OnClose();
	}
*/
}

LRESULT CMainDlg::OnNewData(WPARAM wParam, LPARAM lParam)
{

	EnterCriticalSection(&CrSect);
	
	m_Osc0.Clear();
	m_Osc0.Draw(ThreadData.pData0, 0, ThreadData.nSize0, 0);

	m_Osc1.Clear();
	m_Osc1.Draw(ThreadData.pData1, 0, ThreadData.nSize1, 0);
	
	LeaveCriticalSection(&CrSect);

	return 0;
}
