#if !defined(AFX_OSCVIEW_H__988539E8_1E4C_49F8_BF79_FAD9204E0EED__INCLUDED_)
#define AFX_OSCVIEW_H__988539E8_1E4C_49F8_BF79_FAD9204E0EED__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// OscView.h : header file
//
#include <vector>
using namespace std;

class CBaseView : public CStatic
{
public:
	CBaseView();
	BOOL Create(CWnd* parent,int nResourceID);
	void Clear(void);
	
	CGdiObject* SelectStockObject(int index);
	CPen* SelectObject(CPen* pen);
	CBrush* SelectObject(CBrush* brush);
	CPoint MoveTo(int x,int y);
	BOOL LineTo(int x,int y);
	BOOL SetPixelV(int x,int y,COLORREF color);
	BOOL PolyLine(POINT* points,int num_points);
	BOOL PatBlt(int x0,int y0,int x1,int y1,int op);
	void FillSolidRect(int x0,int y0,int x1,int y1,COLORREF color);
	
	BOOL TextOut(int x,int y,CString& str);
	
	void OnPaint(void);
	void RePaint(void);
	
	int GetWidth(void);
	int GetHeight(void);
	
private:
	CDC     m_memDC;
	CBitmap m_vwnd;
	CBrush  m_brush;
	CRect   m_rect;
	CWnd*   m_pWndParent;
	CWnd*   m_pWndView;
	
}; // class CBaseView

/////////////////////////////////////////////////////////////////////////////

// COscView window

class COscView : public CBaseView
{
// Construction
public:
	COscView();

// Attributes
public:

// Operations
protected:
	void Copy(USHORT *vect, USHORT *vect2, ULONG size, ULONG size2);
	BOOL DrawScale(void);		
public:
	BOOL Create(CWnd* pParentWnd,int nResourceID, USHORT nBits);
	void Draw(USHORT *vect, USHORT *vect2, ULONG size, ULONG size2);
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(COscView)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~COscView();
protected:
	CPen        m_sclPen;
	CPen        m_sigPen;
	CPen		m_sigPen2;
	vector<CPoint> m_points;
	vector<CPoint> m_points2;
	USHORT		m_nBits;
	
	// Generated message map functions
protected:
	//{{AFX_MSG(COscView)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_OSCVIEW_H__988539E8_1E4C_49F8_BF79_FAD9204E0EED__INCLUDED_)
