// SigViewer.cpp : Implementation of CSigViewer
#include "stdafx.h"
#include "BXPlugin.h"
#include "SigViewer.h"
#include "BXDApp.h"
#include "MainDlg.h"

extern CThreadData ThreadData;
extern CRITICAL_SECTION CrSect; 
extern bool bDlgCreated;


/////////////////////////////////////////////////////////////////////////////
// CSigViewer


STDMETHODIMP CSigViewer::get_Title(BSTR *pVal)
{
	AFX_MANAGE_STATE(AfxGetAppModuleState());
//    
	CComBSTR s("EXE BoxDO PlugIn");
	*pVal = s.Detach();
	return S_OK;
}


STDMETHODIMP CSigViewer::AttachDevice(BSTR DeviceID)
{
	AFX_MANAGE_STATE(AfxGetAppModuleState());
	if (!bDlgCreated){
		((CBXDApp *)AfxGetApp())->CreateDlgThread();
	}
	else{
		ThreadData.pDlg->ShowWindow(SW_SHOW);
	}	
	 return S_OK;
}

STDMETHODIMP CSigViewer::DetachDevice(BSTR DeviceID)
{
	AFX_MANAGE_STATE(AfxGetAppModuleState());
	ThreadData.pDlg->ShowWindow(SW_HIDE);

	return S_OK;
}

STDMETHODIMP CSigViewer::OnStart(BSTR DeviceID)
{
	AFX_MANAGE_STATE(AfxGetAppModuleState());
	return S_OK;
}

STDMETHODIMP CSigViewer::OnStop(BSTR DeviceID)
{
	AFX_MANAGE_STATE(AfxGetAppModuleState());
	return S_OK;
}
// :
//    -  /
STDMETHODIMP CSigViewer::OnDataReady(
		/*[in]*/ BSTR DeviceID, 
// Config
//		/*[in]*/ double fTriggerLevel,
		/*[in]*/ double fSamplingTime,
		/*[in]*/ BOOL bInterleaving,		
		/*[in, size_is(2)]*/ BOOL* bChannelEnabled,
		/*[in, size_is(2)]*/ double* fZeroLevel,
		/*[in, size_is(2)]*/ double* fVoltsPerCode,
// Data
		/*[in]*/ int nSize0,
		/*[in, size_is(nSize0)]*/ unsigned short* pData0,
		/*[in]*/ int nSize1,
		/*[in, size_is(nSize1)]*/ unsigned short* pData1)
{
	AFX_MANAGE_STATE(AfxGetAppModuleState());
//	MessageBox(NULL,"Data Ready", "!!!!", 0);
	EnterCriticalSection(&CrSect);
	
	if (!ThreadData.bUpdate){
		LeaveCriticalSection(&CrSect);
		return S_OK;
	}

	ThreadData.DeviceID = DeviceID;
	ThreadData.fSamplingTime = fSamplingTime;
	ThreadData.bInterleaving = bInterleaving;
	ThreadData.bChannelEnabled0 = bChannelEnabled[0];
	ThreadData.bChannelEnabled1 = bChannelEnabled[1];
	ThreadData.fZeroLevel0 = fZeroLevel[0];
	ThreadData.fZeroLevel1 = fZeroLevel[1];
	ThreadData.fVoltsPerCode0 = fVoltsPerCode[0];
	ThreadData.fVoltsPerCode1 = fVoltsPerCode[1];
//////////////////////////////////////////////////////////////////////////

//	if (ThreadData.fZeroLevel1 == 0)
//		MessageBox(NULL,"ThreadData.fZeroLevel1 == 0","Works", 0);
//////////////////////////////////////////////////////////////////////////

	if (!ThreadData.pData0){
		ThreadData.pData0 = new USHORT[nSize0];
	}
	else 
		if (nSize0 != ThreadData.nSize0){
			delete [] ThreadData.pData0;
			ThreadData.pData0 = new USHORT[nSize0];
		}
	memcpy(ThreadData.pData0, pData0, nSize0*sizeof (USHORT));

	if (!ThreadData.pData1){
		ThreadData.pData1 = new USHORT[nSize1];
	}
	else 
		if (nSize1 != ThreadData.nSize1){
			delete [] ThreadData.pData1;
			ThreadData.pData1 = new USHORT[nSize1];
		}
	memcpy(ThreadData.pData1, pData1, nSize1*sizeof (USHORT));

	ThreadData.nSize0 = nSize0;
	ThreadData.nSize1 = nSize1;

	//Time to Update
	if ((ThreadData.pDlg)&&(ThreadData.pDlg->GetSafeHwnd())){
		::PostMessage(ThreadData.pDlg->GetSafeHwnd(), WM_NEWDATA, 0, 0);
	}
	LeaveCriticalSection(&CrSect);

	return S_OK;
}


STDMETHODIMP CSigViewer::OnParamsReady(/*[in]*/ BSTR DeviceID,
		/*[in]*/ ParameterArea nArea, //   
		/*[in, size_is(2)]*/ double* fCursorTimes, //  
		/*[in]*/ int nCount, //   
		/*[in, size_is(nCount)]*/ ParameterType* pTypes, //  
		/*[in, size_is(nCount)]*/ double* pValues0,
		/*[in, size_is(nCount)]*/ double* pValues1) // 
{
/*	if (!m_OutFile.is_open())
		return E_FAIL;
	m_OutFile << "Area = " << ParamAreaToStr[nArea].title << "\n";
	m_OutFile << "Cursor1 = " << fCursorTimes[0] << "; Cursors = " << fCursorTimes[1] << "\n";
	m_OutFile << "Parameters Count = " << nCount << "\n";
	m_OutFile << "Parameter\tChannel0\tChannel1\n";
	for (int i=0; i<nCount; i++)
		m_OutFile << ParamTypeToStr[pTypes[i]].description << "\t" << pValues0[i] << "\t" << pValues1[i] << "\n";
*/	
	AFX_MANAGE_STATE(AfxGetAppModuleState());
	return S_OK;
}

