// SigViewer.h : Declaration of the CSigViewer

#ifndef __SIGVIEWER_H_
#define __SIGVIEWER_H_

#include "resource.h"       // main symbols
#include "boxdoplugin.h"
/////////////////////////////////////////////////////////////////////////////
// CSigViewer
//      BoxDO
//   get_Title, AttachDevice, DetachDevice, OnDataReady  
class ATL_NO_VTABLE CSigViewer : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CSigViewer, &CLSID_SigViewer>,
//	public IBoxDOPlugin2
	public IDispatchImpl<IBoxDOPlugin, &IID_IBoxDOPlugin, &LIBID_BXPLUGINLib>
{
public:
	CSigViewer()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_SIGVIEWER)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CSigViewer)
	COM_INTERFACE_ENTRY(IBoxDOPlugin)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()


BEGIN_CATEGORY_MAP(CSigViewer)
IMPLEMENTED_CATEGORY(CATID_BOXDOPLUGIN)
END_CATEGORY_MAP()


public:
public:
	STDMETHOD(OnStop)(/*[in]*/ BSTR DeviceID);
	STDMETHOD(OnStart)(/*[in]*/ BSTR DeviceID);
	STDMETHOD(DetachDevice)(/*[in]*/ BSTR DeviceID);
	STDMETHOD(AttachDevice)(/*[in]*/ BSTR DeviceID);
	STDMETHOD(get_Title)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(OnDataReady)(
		/*[in]*/ BSTR DeviceID, 
		// Config		
		/*[in]*/ double fSamplingTime,
		/*[in]*/ BOOL bInterleaving,
		/*[in, size_is(2)]*/ BOOL* bChannelEnabled,
		/*[in, size_is(2)]*/ double* fZeroLevel,
		/*[in, size_is(2)]*/ double* fVoltsPerCode,
		// Data
		/*[in]*/ int nSize0,
		/*[in, size_is(nSize0)]*/ WORD* pData0,
		/*[in]*/ int nSize1,
		/*[in, size_is(nSize1)]*/ WORD* pData1);

		STDMETHOD(OnParamsReady)(/*[in]*/ BSTR DeviceID,
		/*[in]*/ ParameterArea nArea, //   
		/*[in, size_is(2)]*/ double* fCursorTimes, //  
		/*[in]*/ int nCount, //   
		/*[in, size_is(nCount)]*/ ParameterType* pTypes, //  
		/*[in, size_is(nCount)]*/ double* pValues0,
		/*[in, size_is(nCount)]*/ double* pValues1); // 
};

#endif //__SIGVIEWER_H_
