// bxdclbr.h:
//
// BoxDo oscilloscope calibration routings interfac unit
//////////////////////////////////////////////////////////////////////

#if !defined(__BXDCLBR_H__)
#define __BXDCLBR_H__

#define BoxDOVoltsCount (BoxDOVoltsMax+1)

#define BXDCLBR_CALLTYPE __stdcall

#include "doiointf.h"

///////////////////////////////////////////////////////////////////////////////
///		 
///////////////////////////////////////////////////////////////////////////////

struct CLinearCalibrationData //     
{
	double m_fLevel; //  
	double m_fCoef; //   y = m_fLevel + x * m_fCoef;
};


///////////////////////////////////////////////////////////////////////
//    

struct CBoxDOChannelCalibrationData
{
	WORD m_Gain[BoxDOVoltsCount]; 
	//    

	WORD m_GainDF[BoxDOVoltsCount]; 
	//        

	CLinearCalibrationData m_TriggerLevelDC[BoxDOVoltsCount]; 
	//     (   )

	CLinearCalibrationData m_ZeroLevel[BoxDOVoltsCount]; 
	//    

	CLinearCalibrationData m_TriggerLevelAC[BoxDOVoltsCount]; 
	//     (   )

	WORD m_nInterleavingMin;
	WORD m_nInterleavingMax;
	//    RIS 
};

///////////////////////////////////////////////////////////////////
//   
struct CBoxDOCalibrationData
{
	CBoxDOChannelCalibrationData m_Channels[BoxDOChannelsCount];
	//    

    WORD m_nInterleavingMin;
	WORD m_nInterleavingMax;
	//    RIS  ???
	
    WORD m_CalibratorData[BoxDOVoltsCount]; 
	//      ()

	CLinearCalibrationData m_TriggerLevelExt;
	//        

	CLinearCalibrationData m_TriggerLevelExt1_10;
	//         1:10

	WORD m_nChargingRate;
	//   ???
public:
};

BOOL BXDCLBR_CALLTYPE InitBoxDOCalibrationData(CBoxDOCalibrationData& Data, BOOL bInitChannels);
//    BoxDO   
// bInitChannels = TRUE -   

BOOL BXDCLBR_CALLTYPE InitBoxDOChannelCalibrationData(CBoxDOChannelCalibrationData& Data);
//     BoxDO   

int BXDCLBR_CALLTYPE SerializeBoxDOCalibrationData(const CDeviceID& ID, CBoxDOCalibrationData& Data, BOOL bStore);
//  /       bStore = TRUE - , FALSE - 
/*  -  
 ,   1		

0								  /    
1								  /     
2								  /     
3								  /     
4								  /    RIS-
					
8								  ,    
9								   1- 
10								   2- 
*/


/////////////////////////////////////////////////////////////////////////////////////////////
///   /   
/////////////////////////////////////////////////////////////////////////////////////////////

BOOL BXDCLBR_CALLTYPE InitOscInfo(COscilloscopeIOControlInfo& oscinfo, const CBoxDOCalibrationData& CalData, BOOL bInitData, int nVolts, int nFrequency);
//      
//      
//     COscilloscopeIOControlInfo   ClearOscInfo


BOOL BXDCLBR_CALLTYPE ClearOscInfo(COscilloscopeIOControlInfo& oscinfo);
// ,     COscilloscopeIOControlInfo


///////////////////////////////////////////////////////////////////////////////////////////////
/// 
//      . 0 -  
///////////////////////////////////////////////////////////////////////////////////////////////

//  

#define INIT_FAILED (-1) //    

//        (1 << (nVolts + nChannel * BoxDOVoltsCount))
//  nVolts  nChannel -   ,     

int BXDCLBR_CALLTYPE CalibrateGain(CDeviceID& ID, CBoxDOCalibrationData& CalData, int nVoltage, int nChannel);
//    .   CalData.m_Channels.m_Gain(DF)


int BXDCLBR_CALLTYPE CalibrateZeroLevel(CDeviceID& ID, CBoxDOCalibrationData& CalData, int nVoltage, int nChannel);
//    .   CalData.m_Channels.m_ZeroLevel


int BXDCLBR_CALLTYPE CalibrateTriggerLevel(CDeviceID& ID, CBoxDOCalibrationData& CalData, int nVolts, int nChannel);
//    .   *.m_TriggerLevel*

int BXDCLBR_CALLTYPE CalibrateRIS(CDeviceID& ID, CBoxDOCalibrationData& CalData);
//   RIS -  (  InterleavingMax, InterleavingMax)

//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
// .	      ,
//				    
/////////////////////////////////////////////////////////////////////////////////

//      <=>   
double BXDCLBR_CALLTYPE CodeToZeroLevel(int nCode, int nChannel, int nVolts, const CBoxDOCalibrationData& CalData);
int BXDCLBR_CALLTYPE ZeroLevelToCode(double fLevel, int nChannel, int nVolts, const CBoxDOCalibrationData& CalData, double* pfError/*may be NULL*/);

//      <=>   
double BXDCLBR_CALLTYPE CodeToTriggerLevel(int nCode, int nVolts, TriggerSource ts, TriggerCoupling tc, double fZeroLevel, const CBoxDOCalibrationData& CalData);
int BXDCLBR_CALLTYPE TriggerLevelToCode(double fLevel, int nVolts, TriggerSource ts, TriggerCoupling tc, double fZeroLevel, const CBoxDOCalibrationData& CalData, double* pfError/*may be NULL*/);

#endif // __BXDCLBR_H__