#ifndef ____SET_MODE_INTF_
#define ____SET_MODE_INTF_

//////////////////////////////////////////////////////////////////////////
// Alternative method is presented here to call UniLPTX.dll functions
// Lib header (for ordinary include) is \Common\Include\__UniLPTX.h
//////////////////////////////////////////////////////////////////////////

#include <windows.h>

#ifndef UNILPTX_API
#define UNILPTX_API __cdecl
#endif

typedef int  (UNILPTX_API *PUniLPTXGetModesCount)(void);
typedef BOOL (UNILPTX_API *PUniLPTXGetModeInfo)(int nIndex, LPTSTR lpszTitle, int MaxSize, BOOL* pbEnabled = NULL, int* pnPortNumber = NULL);
typedef BOOL (UNILPTX_API *PUniLPTXEnableMode)(int nIndex, BOOL bEnable, int nPortNumber = -1);
typedef int  (UNILPTX_API *PUniLPTXGetActiveMode)(void);
typedef int  (UNILPTX_API *PUniLPTXSetMode)(int nIndex);

__inline void* LoadUniLPTXProc(LPCTSTR lpszProcName) 
{
	static LPCTSTR lpszDrvName = "unilptx.dll";
	static HINSTANCE hLib = NULL;
	if(!hLib) hLib = ::LoadLibrary(lpszDrvName);
	if(!hLib) { printf("UniLPTX.dll not found  "); return NULL; }
	return ::GetProcAddress(hLib, lpszProcName);
}

#ifdef _DEBUG
#define CHECKPROC(pProc) { if (!pProc) throw "Can not find proc"; }
#else
#define CHECKPROC(pProc)
#endif

__inline int UNILPTX_API GetModesCount(void)
{
	static LPCTSTR lpszProcName = "__GetModesCount";
	static PUniLPTXGetModesCount pProc = NULL;
	if(!pProc) pProc = (PUniLPTXGetModesCount)LoadUniLPTXProc(lpszProcName);
	CHECKPROC(pProc);
	if(!pProc) return -1;
	return (*pProc)();
}

__inline BOOL UNILPTX_API GetModeInfo(int nIndex, LPTSTR lpszTitle, int MaxSize, BOOL* pbEnabled = NULL, int* pnPortNumber = NULL)
{
	static LPCTSTR lpszProcName = "__GetModeInfo";
	static PUniLPTXGetModeInfo pProc = NULL;
	if(!pProc) pProc = (PUniLPTXGetModeInfo)LoadUniLPTXProc(lpszProcName);
	CHECKPROC(pProc);
	if(!pProc) return -1;
	return (*pProc)(nIndex, lpszTitle, MaxSize, pbEnabled, pnPortNumber);
}

__inline BOOL UNILPTX_API EnableMode(int nIndex, BOOL bEnable, int nPortNumber = -1)
{
	static LPCTSTR lpszProcName = "__EnableMode";
	static PUniLPTXEnableMode pProc = NULL;
	if(!pProc) pProc = (PUniLPTXEnableMode)LoadUniLPTXProc(lpszProcName);
	CHECKPROC(pProc);
	if(!pProc) return -1;
	return (*pProc)(nIndex, bEnable, nPortNumber);
}

__inline int UNILPTX_API GetActiveMode(void)
{
	static LPCTSTR lpszProcName = "__GetModesCount";
	static PUniLPTXGetActiveMode pProc = NULL;
	if(!pProc) pProc = (PUniLPTXGetActiveMode)LoadUniLPTXProc(lpszProcName);
	CHECKPROC(pProc);
	if(!pProc) return -1;
	return (*pProc)();
}

__inline int UNILPTX_API SetMode(int nIndex)
{
	static LPCTSTR lpszProcName = "__SetMode";
	static PUniLPTXSetMode pProc = NULL;
	if(!pProc) pProc = (PUniLPTXSetMode)LoadUniLPTXProc(lpszProcName);
	CHECKPROC(pProc);
	if(!pProc) return -1;
	return (*pProc)(nIndex);
}

#endif //____SET_MODE_INTF_